;##################################################################
; DIALOGAPP
;##################################################################

#include "HxSessionDemo.h"

DEBUGLIB equ \Programming\RadASM\GoAsm\lib\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\lib\dbgwin.exe"

#include "\Programming\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists

CONST SECTION
	IDD_DLG1	equ		1000

DATA SECTION
	hInst DD ?

	CLSID_IHxSession GUID GUID_CLSID_IHxSession
	IID_IHxSession GUID GUID_IID_IHxSession

	Collection DB "ms-help://MS.MSDNQTR.v90.en",0
	Keyword DB "WM_COMMAND",0

	hWeb DD ?

	pIHxIndex	DD ?
	pIHxSession DD ?
	pbstrCollection DD ?
	pbstrNavMoniker DD ?
	wszCollection DW 1024 DUP (?)

	pbstrNULL DD ?

	szUrl	DB	2048 DUP (?)

CODE SECTION

Start:
	invoke GetModuleHandle,NULL
	mov [hInst],eax

	invoke CoInitialize,NULL

	invoke InitCommonControls

	// Create a NULL BSTR
	invoke SysAllocString,L""
	mov [pbstrNULL],eax
	// Create a BSTR with the navigation moniker
	invoke SysAllocString,L"!DefaultKeywordIndex"
	mov [pbstrNavMoniker],eax
	// Convert the Collection name to unicode then create a BSTR with it
	invoke MultiByteToWideChar,CP_ACP,NULL,offset Collection,-1,offset wszCollection,1024
	invoke SysAllocString,offset wszCollection
	mov [pbstrCollection],eax

	// Create an instance of IHxSession
	invoke CoCreateInstance,offset CLSID_IHxSession, NULL, CLSCTX_ALL,offset IID_IHxSession, offset pIHxSession
	test eax, eax
	jnz >>.ERROR_NO_INTERFACE



	// Set the collection
	CoInvoke(pIHxSession,IHxSession.Initialize,[pbstrCollection],NULL)
	test eax, eax
	jnz >>.ERROR_NO_INIT

	// Get an IHxIndex pointer
	CoInvoke(pIHxSession,IHxSession.GetNavigationObject,[pbstrNavMoniker],[pbstrNULL],offset pIHxIndex)
	test eax, eax
	jnz >>.ERROR_NO_INIT

	invoke LoadLibrary,"WBDll.dll"
	mov [hWeb],eax

	// Display the main dialog
	invoke DialogBoxParam,[hInst],1000,0,OFFSET DlgProc, eax

	.ERROR_NO_INIT
	CoInvoke(pIHxSession,IHxSession.IUnknown.Release)

	.ERROR_NO_INTERFACE
	invoke SysFreeString,[pbstrCollection]
	invoke SysFreeString,[pbstrNavMoniker]
	invoke SysFreeString,[pbstrNULL]

	invoke FreeLibrary,[hWeb]

	invoke CoUninitialize
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL lbtext[1024]:B

	cmp D[uMsg], WM_INITDIALOG
	jne >>.WM_COMMAND
		invoke GetDlgItem,[hwnd],1002
		invoke BuildKeywordList,eax,5000,100
		invoke GetKeywordURL,offset Keyword,offset szUrl
		invoke SendDlgItemMessage,[hwnd],1001,WBM_NAVIGATE,0,offset szUrl
		xor eax,eax
		RET

	.WM_COMMAND
	cmp D[uMsg], WM_COMMAND
	jne >>.WM_CLOSE
		movzx eax,W[wParam+2]
		cmp eax,LBN_DBLCLK
		jne >>.DEFPROC
			invoke SendDlgItemMessage,[hwnd],1002,LB_GETCURSEL,0,0
			invoke SendDlgItemMessage,[hwnd],1002,LB_GETTEXT,eax,offset lbtext
			invoke GetKeywordURL,offset lbtext,offset szUrl
			invoke SendDlgItemMessage,[hwnd],1001,WBM_NAVIGATE,0,offset szUrl
			xor eax,eax
			RET

	.WM_CLOSE
	cmp D[uMsg], WM_CLOSE
	jne >.DEFPROC
		invoke EndDialog,[hwnd],0

	.DEFPROC
	xor eax,eax
	RET
ENDF

GetKeywordURL FRAME pszKeyword, pUrl
	LOCAL wszKeyword[1024]:W
	LOCAL pbstrKeyword:D
	LOCAL pOutUrl:D
	LOCAL pIHxTopic:D

	// Allocate an uninitialed string to return the URL
	invoke SysAllocStringLen ,NULL,1024
	mov [pOutUrl],eax

	invoke RtlZeroMemory,eax,64

	// Convert the keyword to unicode then create a BSTR with it
	invoke MultiByteToWideChar,CP_ACP,NULL,[pszKeyword],-1,offset wszKeyword,1024
	invoke SysAllocString,offset wszKeyword
	mov [pbstrKeyword],eax

	// Get the URL for the keyword
	CoInvoke(pIHxSession,IHxSession.QueryForUrl,[pbstrKeyword],[pbstrNavMoniker],0,[pbstrNULL],[pOutUrl])
	test eax, eax
	jnz >>.ERROR

	// Convert the url to ANSI
	mov eax,[pOutUrl]
	mov eax,[eax]
	invoke WideCharToMultiByte,CP_ACP,NULL,eax,-1,[pUrl],1024,"",NULL

	// Free the BSTR data
	invoke SysFreeString,[pbstrKeyword]
	invoke SysFreeString,[pOutUrl]

	// Return S_OK
	xor eax,eax
	RET

	.ERROR
	invoke SysFreeString,[pbstrKeyword]
	invoke SysFreeString,[pOutUrl]

	RET
ENDF

BuildKeywordList FRAME hwnd, iFirst, nItems
	uses ebx
	LOCAL pIHxTopicList:D
	LOCAL count:D
	LOCAL EndCount:D
	LOCAL pbszLink:D

	invoke SendMessage,[hwnd],LB_RESETCONTENT,0,0

	// Allocate an uninitialed string to return the URL
	invoke SysAllocStringLen ,NULL,1024
	mov [pbszLink],eax

	mov eax,[iFirst]
	add eax,[nItems]
	mov [EndCount],eax

	CoInvoke(pIHxIndex,IHxIndex.Count,offset count)

	test eax, eax
	jnz >>.ERROR

	cmp D[count],0
	je >>.ERROR

	// Calculate the string space needed
	// Average of 64 bytes per title
	invoke SendMessage,[hwnd],LB_INITSTORAGE,[count],64

	mov ebx,[iFirst]
	:
		CoInvoke(pIHxIndex,IHxIndex.GetStringFromSlot,ebx,[pbszLink])
		mov eax,[pbszLink]
		mov eax,[eax]
		invoke SendMessageW,[hwnd],LB_ADDSTRING,0,eax
		inc ebx
		cmp ebx,[EndCount]
		jl <<

	invoke SysFreeString,[pbszLink]

	xor eax,eax
	RET

	.ERROR
	invoke SysFreeString,[pbszLink]
	xor eax,eax
	dec eax
	RET
ENDF
